require("Atlas.AtlasHelpers");
luanet.load_assembly("log4net");

local settings = {};
settings.AutoSearch = GetSetting("AutoSearch");

local interfaceMngr = nil;
local redshelfSearchForm = {};
redshelfSearchForm.Form = nil;
redshelfSearchForm.Browser = nil;
redshelfSearchForm.RibbonPage = nil;

function Init()
    if (GetFieldValue("Transaction","ProcessType") == "Lending" or GetFieldValue("Transaction","RequestType")=="Article") then
        LogDebug("Addon not applicable to this process type or request type. Cancelling initialization.");
    end
	interfaceMngr = GetInterfaceManager();
	redshelfSearchForm.Form = interfaceMngr:CreateForm("Redshelf", "Script");
	redshelfSearchForm.Browser = redshelfSearchForm.Form:CreateBrowser("Redshelf Search", "Redshelf Search", "Redshelf Search", "Chromium");
	redshelfSearchForm.Browser.TextVisible = false;
	redshelfSearchForm.RibbonPage = redshelfSearchForm.Form:GetRibbonPage("Redshelf Search");
	redshelfSearchForm.RibbonPage:CreateButton("Search", GetClientImage("Search32"), "Search", "Redshelf");
	redshelfSearchForm.Form:Show();
	if settings.AutoSearch then
		Search();
    else
        redshelfSearchForm.Browser:Navigate("https://www.redshelf.com");
    end

end

function Search()
    local searchText = "";
    local isbn = GetFieldValue("Transaction","ISSN");
    if (isbn ~= nil and isbn ~= "") then
        LogDebug("Searching by ISBN");
        searchText = isbn;
    else
        LogDebug("Searching by Title");
        searchText = GetFieldValue("Transaction","LoanTitle");
    end

	redshelfSearchForm.Browser:Navigate("https://www.redshelf.com/search/?terms="..AtlasHelpers.UrlEncode(searchText));
end


